// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	scheme "github.com/pingcap/tidb-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// TidbClusterAutoScalersGetter has a method to return a TidbClusterAutoScalerInterface.
// A group's client should implement this interface.
type TidbClusterAutoScalersGetter interface {
	TidbClusterAutoScalers(namespace string) TidbClusterAutoScalerInterface
}

// TidbClusterAutoScalerInterface has methods to work with TidbClusterAutoScaler resources.
type TidbClusterAutoScalerInterface interface {
	Create(*v1alpha1.TidbClusterAutoScaler) (*v1alpha1.TidbClusterAutoScaler, error)
	Update(*v1alpha1.TidbClusterAutoScaler) (*v1alpha1.TidbClusterAutoScaler, error)
	UpdateStatus(*v1alpha1.TidbClusterAutoScaler) (*v1alpha1.TidbClusterAutoScaler, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.TidbClusterAutoScaler, error)
	List(opts v1.ListOptions) (*v1alpha1.TidbClusterAutoScalerList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbClusterAutoScaler, err error)
	TidbClusterAutoScalerExpansion
}

// tidbClusterAutoScalers implements TidbClusterAutoScalerInterface
type tidbClusterAutoScalers struct {
	client rest.Interface
	ns     string
}

// newTidbClusterAutoScalers returns a TidbClusterAutoScalers
func newTidbClusterAutoScalers(c *PingcapV1alpha1Client, namespace string) *tidbClusterAutoScalers {
	return &tidbClusterAutoScalers{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the tidbClusterAutoScaler, and returns the corresponding tidbClusterAutoScaler object, and an error if there is any.
func (c *tidbClusterAutoScalers) Get(name string, options v1.GetOptions) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	result = &v1alpha1.TidbClusterAutoScaler{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of TidbClusterAutoScalers that match those selectors.
func (c *tidbClusterAutoScalers) List(opts v1.ListOptions) (result *v1alpha1.TidbClusterAutoScalerList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.TidbClusterAutoScalerList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested tidbClusterAutoScalers.
func (c *tidbClusterAutoScalers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a tidbClusterAutoScaler and creates it.  Returns the server's representation of the tidbClusterAutoScaler, and an error, if there is any.
func (c *tidbClusterAutoScalers) Create(tidbClusterAutoScaler *v1alpha1.TidbClusterAutoScaler) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	result = &v1alpha1.TidbClusterAutoScaler{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		Body(tidbClusterAutoScaler).
		Do().
		Into(result)
	return
}

// Update takes the representation of a tidbClusterAutoScaler and updates it. Returns the server's representation of the tidbClusterAutoScaler, and an error, if there is any.
func (c *tidbClusterAutoScalers) Update(tidbClusterAutoScaler *v1alpha1.TidbClusterAutoScaler) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	result = &v1alpha1.TidbClusterAutoScaler{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		Name(tidbClusterAutoScaler.Name).
		Body(tidbClusterAutoScaler).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *tidbClusterAutoScalers) UpdateStatus(tidbClusterAutoScaler *v1alpha1.TidbClusterAutoScaler) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	result = &v1alpha1.TidbClusterAutoScaler{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		Name(tidbClusterAutoScaler.Name).
		SubResource("status").
		Body(tidbClusterAutoScaler).
		Do().
		Into(result)
	return
}

// Delete takes name of the tidbClusterAutoScaler and deletes it. Returns an error if one occurs.
func (c *tidbClusterAutoScalers) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *tidbClusterAutoScalers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched tidbClusterAutoScaler.
func (c *tidbClusterAutoScalers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	result = &v1alpha1.TidbClusterAutoScaler{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("tidbclusterautoscalers").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
